﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataTreeDeleteNode
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ViewModel vm = new ViewModel();
            this.DataContext = vm;
        }

        private void btnDelete_Click(object sender, RoutedEventArgs e)
        {
            ObservableCollection<TreeElement> ParentColl = MyTree.ItemsSource as ObservableCollection<TreeElement>;

            TreeElement Parent = ParentColl[1];

            TreeElement ChildItem = Parent.Children.FirstOrDefault();

            Parent.Children.Remove(ChildItem);
        }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            ParentColl = new ObservableCollection<TreeElement>();
            ParentColl.Add(new TreeElement() { Name = "Parent 1" });
            ParentColl.Add(new TreeElement() { Name = "Parent 2" });
        }
        public ObservableCollection<TreeElement> ParentColl { get; set; }
    }

    public class TreeElement

    {
        private ObservableCollection<TreeElement> _childNodes;

        public string Name { get; set; }

        public ObservableCollection<TreeElement> Children
        {
            get
            {
                if (this._childNodes == null)
                {
                    this._childNodes = new ObservableCollection<TreeElement>();
                    this._childNodes.Add(new TreeElement() { Name = "Child 1" });
                }

                return this._childNodes;
            }
        }

    }
}
